#ifndef ATL_ztGetNB_geqrf

/*
 * NB selection for GEQRF: Side='RIGHT', Uplo='UPPER'
 * M : 25,128,192,320,704,1024,1408
 * N : 25,128,192,320,704,1024,1408
 * NB : 2,16,64,24,16,64,64
 */
#define ATL_ztGetNB_geqrf(n_, nb_) \
{ \
   if ((n_) < 76) (nb_) = 2; \
   else if ((n_) < 160) (nb_) = 16; \
   else if ((n_) < 256) (nb_) = 64; \
   else if ((n_) < 512) (nb_) = 24; \
   else if ((n_) < 864) (nb_) = 16; \
   else (nb_) = 64; \
}


#endif    /* end ifndef ATL_ztGetNB_geqrf */
